'' This program requires a PropCAM-DB (#28320) plugged into a Propeller Backpack (#28327).
'' For other hosts, change the CON section below to accommodate.

CON

'' Clock mode for Propeller Backpack. Can be changed for other Propeller modules.

  _clkmode      = xtal1 + pll8x
  _xinfreq      = 10_000_000

'' Pin definitions for Propeller Backpack. Can be changed for other Propeller modules.

  SCL           = 4
  SDA           = 5
  VSYNC         = 6
  MCLK          = 7
  DATA          = 0
  HSYNC         = 3

DAT

  my_pins               byte    SCL, SDA, VSYNC, MCLK, DATA, HSYNC

VAR

  byte  hold

OBJ

  cam   : "PropCAM_parallel4"     '4-bit-per-pixel PropCAM driver.
  mon   : "PropCAM_monitor4"      'Monitor program to send pixels via FullDuplexSerial.
   
PUB start | ch

  gray_buf_addr := @gray_buf
  cam.start(cam#SNAPSHOT, @my_pins, @gray_buf_addr)
  mon.start(gray_buf_addr, @hold)
  repeat
    repeat while (hold)
    cam.acquire(cam#GRAB)

DAT

gray_buf      long      cam#PIXELS_PER_ROW << 16 | cam#ROWS_PER_FRAME, $aaaaaaaa[cam#LONGS_PER_ROW * cam#ROWS_PER_FRAME]

gray_buf_addr word      0-0                     '@gray_buf gets plugged in here.
left          word      0                       'Lefmost pixel in gray_buf for capture.
top           word      0                       'Topmost oixel in gray_buf for capture.
exp_type      word      cam#AUTOBOTH            'Set exposure mode to automatically adjust gain and exposure time.
sync_addr     word      0-0                     '@sync gets plugged in here.
exp_time      word      20                      'Start with minimum exposure time.
gain          word      $0f                     'Start with medium gain.
target        word      600                     'Autoexposure target for avg_pix.
time_interval word      -30                     'Initial exporsure time = 1/3 sec.
avg_pix       word      0-0                     'Average pixel value from last capture * 100.